#include "events.h"

int Event::Exist()
{
	return (int) head;
}

int Event::Put( int trans, int time )
{
	Node *tmp= new Node;
	Node **cur= &head;

	tmp->time= time;
	tmp->transition= trans;
	
	// find insertion point
	for( cur= &head; *cur && ((*cur)->time < time); cur= &((*cur)->next) );

	// insert
	tmp->next= *cur;
	*cur= tmp;

}

int Event::Get( int &GVT )
{
	Node *tmp= head;
	int trans= tmp->transition;

	GVT= tmp->time;
	head= head->next;
	delete tmp;

	return(trans);
}

int Event::NextTimeStamp()
{
	return( head?head->time:0);
}
